module: dylan-user

define module ir-protocol
  use common-dylan;
  use corba-protocol;
  use orb-core;
  export
    CORBA/<ScopedName>,
    CORBA/<DefinitionKind>,
    CORBA/DefinitionKind/successor,
    CORBA/DefinitionKind/predecessor,
    CORBA/DefinitionKind/>,
    CORBA/DefinitionKind/<,
    CORBA/<IRObject>,
    CORBA/IRObject/def-kind,
    CORBA/IRObject/destroy,
    CORBA/<VersionSpec>,
    CORBA/<Contained>,
    CORBA/<Repository>,
    CORBA/<Container>,
    CORBA/<ExceptionDef>,
    CORBA/<WstringDef>,
    CORBA/<FixedDef>,
    CORBA/Contained/id,
    CORBA/Contained/id-setter,
    CORBA/Contained/name,
    CORBA/Contained/name-setter,
    CORBA/Contained/version,
    CORBA/Contained/version-setter,
    CORBA/Contained/defined-in,
    CORBA/Contained/absolute-name,
    CORBA/Contained/containing-repository,
    CORBA/Contained/<Description>,
    CORBA/Contained/Description/kind,
    CORBA/Contained/Description/kind-setter,
    CORBA/Contained/Description/value,
    CORBA/Contained/Description/value-setter,
    CORBA/Contained/describe,
    CORBA/Contained/move,
    CORBA/<ModuleDef>,
    CORBA/<ConstantDef>,
    CORBA/<IDLType>,
    CORBA/<StructDef>,
    CORBA/<UnionDef>,
    CORBA/<EnumDef>,
    CORBA/<AliasDef>,
    CORBA/<InterfaceDef>,
    CORBA/<InterfaceDefSeq>,
    CORBA/<ContainedSeq>,
    CORBA/<StructMember>,
    CORBA/StructMember/name,
    CORBA/StructMember/name-setter,
    CORBA/StructMember/type,
    CORBA/StructMember/type-setter,
    CORBA/StructMember/type-def,
    CORBA/StructMember/type-def-setter,
    CORBA/<StructMemberSeq>,
    CORBA/<UnionMember>,
    CORBA/UnionMember/name,
    CORBA/UnionMember/name-setter,
    CORBA/UnionMember/label,
    CORBA/UnionMember/label-setter,
    CORBA/UnionMember/type,
    CORBA/UnionMember/type-setter,
    CORBA/UnionMember/type-def,
    CORBA/UnionMember/type-def-setter,
    CORBA/<UnionMemberSeq>,
    CORBA/<EnumMemberSeq>,
    CORBA/Container/lookup,
    CORBA/Container/contents,
    CORBA/Container/lookup-name,
    CORBA/Container/<Description>,
    CORBA/Container/Description/contained-object,
    CORBA/Container/Description/contained-object-setter,
    CORBA/Container/Description/kind,
    CORBA/Container/Description/kind-setter,
    CORBA/Container/Description/value,
    CORBA/Container/Description/value-setter,
    CORBA/Container/<DescriptionSeq>,
    CORBA/Container/describe-contents,
    CORBA/Container/create-module,
    CORBA/Container/create-constant,
    CORBA/Container/create-struct,
    CORBA/Container/create-union,
    CORBA/Container/create-enum,
    CORBA/Container/create-alias,
    CORBA/Container/create-interface,
    CORBA/Container/create-exception,
    CORBA/IDLType/type,
    CORBA/<PrimitiveDef>,
    CORBA/<StringDef>,
    CORBA/<SequenceDef>,
    CORBA/<ArrayDef>,
    CORBA/<PrimitiveKind>,
    CORBA/PrimitiveKind/successor,
    CORBA/PrimitiveKind/predecessor,
    CORBA/PrimitiveKind/>,
    CORBA/PrimitiveKind/<,
    CORBA/Repository/lookup-id,
    CORBA/Repository/get-primitive,
    CORBA/Repository/create-string,
    CORBA/Repository/create-wstring,
    CORBA/Repository/create-sequence,
    CORBA/Repository/create-array,
    CORBA/Repository/create-fixed,
    CORBA/<ModuleDescription>,
    CORBA/ModuleDescription/name,
    CORBA/ModuleDescription/name-setter,
    CORBA/ModuleDescription/id,
    CORBA/ModuleDescription/id-setter,
    CORBA/ModuleDescription/defined-in,
    CORBA/ModuleDescription/defined-in-setter,
    CORBA/ModuleDescription/version,
    CORBA/ModuleDescription/version-setter,
    CORBA/ConstantDef/type,
    CORBA/ConstantDef/type-def,
    CORBA/ConstantDef/type-def-setter,
    CORBA/ConstantDef/value,
    CORBA/ConstantDef/value-setter,
    CORBA/<ConstantDescription>,
    CORBA/ConstantDescription/name,
    CORBA/ConstantDescription/name-setter,
    CORBA/ConstantDescription/id,
    CORBA/ConstantDescription/id-setter,
    CORBA/ConstantDescription/defined-in,
    CORBA/ConstantDescription/defined-in-setter,
    CORBA/ConstantDescription/version,
    CORBA/ConstantDescription/version-setter,
    CORBA/ConstantDescription/type,
    CORBA/ConstantDescription/type-setter,
    CORBA/ConstantDescription/value,
    CORBA/ConstantDescription/value-setter,
    CORBA/<TypedefDef>,
    CORBA/<TypeDescription>,
    CORBA/TypeDescription/name,
    CORBA/TypeDescription/name-setter,
    CORBA/TypeDescription/id,
    CORBA/TypeDescription/id-setter,
    CORBA/TypeDescription/defined-in,
    CORBA/TypeDescription/defined-in-setter,
    CORBA/TypeDescription/version,
    CORBA/TypeDescription/version-setter,
    CORBA/TypeDescription/type,
    CORBA/TypeDescription/type-setter,
    CORBA/StructDef/members,
    CORBA/StructDef/members-setter,
    CORBA/UnionDef/discriminator-type,
    CORBA/UnionDef/discriminator-type-def,
    CORBA/UnionDef/discriminator-type-def-setter,
    CORBA/UnionDef/members,
    CORBA/UnionDef/members-setter,
    CORBA/EnumDef/members,
    CORBA/EnumDef/members-setter,
    CORBA/AliasDef/original-type-def,
    CORBA/AliasDef/original-type-def-setter,
    CORBA/PrimitiveDef/kind,
    CORBA/StringDef/bound,
    CORBA/StringDef/bound-setter,
    CORBA/WstringDef/bound,
    CORBA/WstringDef/bound-setter,
    CORBA/FixedDef/digits,
    CORBA/FixedDef/digits-setter,
    CORBA/FixedDef/scale,
    CORBA/FixedDef/scale-setter,
    CORBA/SequenceDef/bound,
    CORBA/SequenceDef/bound-setter,
    CORBA/SequenceDef/element-type,
    CORBA/SequenceDef/element-type-def,
    CORBA/SequenceDef/element-type-def-setter,
    CORBA/ArrayDef/length,
    CORBA/ArrayDef/length-setter,
    CORBA/ArrayDef/element-type,
    CORBA/ArrayDef/element-type-def,
    CORBA/ArrayDef/element-type-def-setter,
    CORBA/ExceptionDef/type,
    CORBA/ExceptionDef/members,
    CORBA/ExceptionDef/members-setter,
    CORBA/<ExceptionDescription>,
    CORBA/ExceptionDescription/name,
    CORBA/ExceptionDescription/name-setter,
    CORBA/ExceptionDescription/id,
    CORBA/ExceptionDescription/id-setter,
    CORBA/ExceptionDescription/defined-in,
    CORBA/ExceptionDescription/defined-in-setter,
    CORBA/ExceptionDescription/version,
    CORBA/ExceptionDescription/version-setter,
    CORBA/ExceptionDescription/type,
    CORBA/ExceptionDescription/type-setter,
    CORBA/<AttributeMode>,
    CORBA/AttributeMode/successor,
    CORBA/AttributeMode/predecessor,
    CORBA/AttributeMode/>,
    CORBA/AttributeMode/<,
    CORBA/<AttributeDef>,
    CORBA/AttributeDef/type,
    CORBA/AttributeDef/type-def,
    CORBA/AttributeDef/type-def-setter,
    CORBA/AttributeDef/mode,
    CORBA/AttributeDef/mode-setter,
    CORBA/<AttributeDescription>,
    CORBA/AttributeDescription/name,
    CORBA/AttributeDescription/name-setter,
    CORBA/AttributeDescription/id,
    CORBA/AttributeDescription/id-setter,
    CORBA/AttributeDescription/defined-in,
    CORBA/AttributeDescription/defined-in-setter,
    CORBA/AttributeDescription/version,
    CORBA/AttributeDescription/version-setter,
    CORBA/AttributeDescription/type,
    CORBA/AttributeDescription/type-setter,
    CORBA/AttributeDescription/mode,
    CORBA/AttributeDescription/mode-setter,
    CORBA/<OperationMode>,
    CORBA/OperationMode/successor,
    CORBA/OperationMode/predecessor,
    CORBA/OperationMode/>,
    CORBA/OperationMode/<,
    CORBA/<ParameterMode>,
    CORBA/ParameterMode/successor,
    CORBA/ParameterMode/predecessor,
    CORBA/ParameterMode/>,
    CORBA/ParameterMode/<,
    CORBA/<ParameterDescription>,
    CORBA/ParameterDescription/name,
    CORBA/ParameterDescription/name-setter,
    CORBA/ParameterDescription/type,
    CORBA/ParameterDescription/type-setter,
    CORBA/ParameterDescription/type-def,
    CORBA/ParameterDescription/type-def-setter,
    CORBA/ParameterDescription/mode,
    CORBA/ParameterDescription/mode-setter,
    CORBA/<ParDescriptionSeq>,
    CORBA/<ContextIdentifier>,
    CORBA/<ContextIdSeq>,
    CORBA/<ExceptionDefSeq>,
    CORBA/<ExcDescriptionSeq>,
    CORBA/<OperationDef>,
    CORBA/OperationDef/result,
    CORBA/OperationDef/result-def,
    CORBA/OperationDef/result-def-setter,
    CORBA/OperationDef/params,
    CORBA/OperationDef/params-setter,
    CORBA/OperationDef/mode,
    CORBA/OperationDef/mode-setter,
    CORBA/OperationDef/contexts,
    CORBA/OperationDef/contexts-setter,
    CORBA/OperationDef/exceptions,
    CORBA/OperationDef/exceptions-setter,
    CORBA/<OperationDescription>,
    CORBA/OperationDescription/name,
    CORBA/OperationDescription/name-setter,
    CORBA/OperationDescription/id,
    CORBA/OperationDescription/id-setter,
    CORBA/OperationDescription/defined-in,
    CORBA/OperationDescription/defined-in-setter,
    CORBA/OperationDescription/version,
    CORBA/OperationDescription/version-setter,
    CORBA/OperationDescription/result,
    CORBA/OperationDescription/result-setter,
    CORBA/OperationDescription/mode,
    CORBA/OperationDescription/mode-setter,
    CORBA/OperationDescription/contexts,
    CORBA/OperationDescription/contexts-setter,
    CORBA/OperationDescription/parameters,
    CORBA/OperationDescription/parameters-setter,
    CORBA/OperationDescription/exceptions,
    CORBA/OperationDescription/exceptions-setter,
    CORBA/<RepositoryIdSeq>,
    CORBA/<OpDescriptionSeq>,
    CORBA/<AttrDescriptionSeq>,
    CORBA/InterfaceDef/base-interfaces,
    CORBA/InterfaceDef/base-interfaces-setter,
    CORBA/InterfaceDef/is-a,
    CORBA/InterfaceDef/<FullInterfaceDescription>,
    CORBA/InterfaceDef/FullInterfaceDescription/name,
    CORBA/InterfaceDef/FullInterfaceDescription/name-setter,
    CORBA/InterfaceDef/FullInterfaceDescription/id,
    CORBA/InterfaceDef/FullInterfaceDescription/id-setter,
    CORBA/InterfaceDef/FullInterfaceDescription/defined-in,
    CORBA/InterfaceDef/FullInterfaceDescription/defined-in-setter,
    CORBA/InterfaceDef/FullInterfaceDescription/version,
    CORBA/InterfaceDef/FullInterfaceDescription/version-setter,
    CORBA/InterfaceDef/FullInterfaceDescription/operations,
    CORBA/InterfaceDef/FullInterfaceDescription/operations-setter,
    CORBA/InterfaceDef/FullInterfaceDescription/attributes,
    CORBA/InterfaceDef/FullInterfaceDescription/attributes-setter,
    CORBA/InterfaceDef/FullInterfaceDescription/base-interfaces,
    CORBA/InterfaceDef/FullInterfaceDescription/base-interfaces-setter,
    CORBA/InterfaceDef/FullInterfaceDescription/type,
    CORBA/InterfaceDef/FullInterfaceDescription/type-setter,
    CORBA/InterfaceDef/describe-interface,
    CORBA/InterfaceDef/create-attribute,
    CORBA/InterfaceDef/create-operation,
    CORBA/<InterfaceDescription>,
    CORBA/InterfaceDescription/name,
    CORBA/InterfaceDescription/name-setter,
    CORBA/InterfaceDescription/id,
    CORBA/InterfaceDescription/id-setter,
    CORBA/InterfaceDescription/defined-in,
    CORBA/InterfaceDescription/defined-in-setter,
    CORBA/InterfaceDescription/version,
    CORBA/InterfaceDescription/version-setter,
    CORBA/InterfaceDescription/base-interfaces,
    CORBA/InterfaceDescription/base-interfaces-setter;
end;

